import sys

BLOCKED = '*'
EMPTY = '.'
WIN = '!'


def print_grid(grid):
    """
    Print the grid with spaces between each value and newlines between each row
    """


def read_grid(filename):
    """
    Read the file as a grid

    Each line becomes a row.
    Spaces delineate each value within a row.
    """


def update_grid(grid, old_row, old_col, new_row, new_col, empty=None):
    """
    Move the value at old_row, old_col to new_row, new_col

    Fill with cell at old_row, old_col with the empty value
    """


def is_blocked(grid, row, col, blocked_value):
    """
    Return True if the value at row, col in the grid is the blocked_value

    Also return True if the row, col coordinate is out of bounds.
    """


def play(grid):
    row = 0
    col = 0
    while True:
        print_grid(grid)
        action = input('Action: ')
        if not action:
            break

        action = action.lower()
        new_row = row
        new_col = col

        if action[0] == 'u':
            if not is_blocked(grid, row - 1, col, blocked_value=BLOCKED):
                new_row = row - 1

        elif action[0] == 'd':
            if not is_blocked(grid, row + 1, col, blocked_value=BLOCKED):
                new_row = row + 1

        elif action[0] == 'l':
            if not is_blocked(grid, row, col - 1, blocked_value=BLOCKED):
                new_col = col - 1

        elif action[0] == 'r':
            if not is_blocked(grid, row, col + 1, blocked_value=BLOCKED):
                new_col = col + 1

        elif action[0] == 'q':
            break

        if row != new_row or col != new_col:
            if grid[new_row][new_col] == WIN:
                update_grid(grid, row, col, new_row, new_col, empty=EMPTY)
                print_grid(grid)
                print('You win!')
                break
            else:
                update_grid(grid, row, col, new_row, new_col, empty=EMPTY)
                row = new_row
                col = new_col


def main(filename):
    grid = read_grid(filename)
    play(grid)


if __name__ == '__main__':
    main(sys.argv[1])
